# Clonezilla на диске в grub

1. Скачать iso образ clonezilla и сохранить на диске

например

```shell
mkdir /iso
cd /iso
wget https://unlimited.dl.sourceforge.net/project/clonezilla/clonezilla_live_stable/3.2.0-5/clonezilla-live-3.2.0-5-amd64.iso
```

2. Определить как диск отображается в grub

2.1. Загрузится в оболочку grub - (хз, как это сделать, в Альт это делается многократным нажатием Esc в момент загрузки)

когда появляется меню grub нужно нажать `c`

после того, как оказался в grub

```shell
grub> ls
```

покажет как grub видит диски системы. Из этих дисков необходимо выбрать тот, на котором расположен iso образ clonezilla.

3. Добавить запись в меню grub

в строке `set root` - необходимо указать диск, на котором находится iso образ

```shell
❯ cat /etc/grub.d/40_custom
#!/bin/sh
exec tail -n +3 $0
# This file provides an easy way to add custom menu entries.  Simply type the
# menu entries you want to add after this comment.  Be careful not to change
# the 'exec tail' line above.

# Clonezilla
menuentry "Backup/Restore HDD with Clonelilla" {
    set root=(hd2,gpt2)
    set isofile="/iso/clonezilla.iso"
    loopback loop $isofile
    linux (loop)/live/vmlinuz boot=live union=overlay username=user config components quiet noswap nolocales edd=on nomodeset ocs_live_run=\"ocs-live-general\" ocs_live_extra_param=\"\" keyboard-layouts= ocs_live_batch=\"no\" locales= vga=788 ip=frommedia nosplash toram=live,syslinux,EFI findiso=$isofile
    initrd (loop)/live/initrd.img
}
```

4. Обновить конфигурацию загрузчика

```shell
update-grub
reboot
```
